//etch functions

var etchBack = 200, rectWidth = 0;
var etch1;
var colors = ['purple','orange','blue','yellow',
                'green','red','pink', 'black', etchBack];

//setup for display
function etchSetup(){
    background(etchBack);
    //play area bounds
    stroke(0);
    strokeWeight(4);
    line(0, 0, 0, height);
    line(0, 0, width, 0);
    line(0, height, width, height);
    line(width, 0, width, width);

    //display color options
    displayColors();

    //make player
    etch1 = makeTurtle(width/2, height/2);
    etch1.setWeight(2);
    etch1.setColor(etchBack);
}

//show color options
function displayColors(){
    //clear top of background
    fill(etchBack);
    stroke(0);
    strokeWeight(4);
    rect(0, 0, width, 45);

    //text instructions
    textAlign(CENTER, TOP);
    textSize(18);
    text("Click to select a color!", width/2, 5);

    //draw color options
    var dispWidth = width - 100;
    rectWidth = dispWidth/colors.length;
    strokeWeight(2);
    for (var i = 0; i < colors.length; i++){
        fill(colors[i]);
        rect(rectWidth*i+50, 25, rectWidth, rectWidth);
    }
}

//mouse pressed for etch - selects color
    /*NOTE: This works fine with a mouse.
        For some reason unknown to me the tracpad
        works inconsistently, so I would recommend 
        using a mouse to test this*/
function etchMousePressed(){
    //check if click is within color
    var x = mouseX;
    var y = mouseY;
    for (var i = 0; i < colors.length; i++){
        if (y > 25 && y < (25 + rectWidth)){
            if (x > rectWidth*i+50 && x < rectWidth*i+50+rectWidth){
                etch1.setColor(colors[i]);
                return true;
            }
        }
    }

    //otherwise place etch somewhere if click is below colors
    if (y > 75){
        etch1.penUp();
        etch1.goto(x,y);
        etch1.penDown();
    }
}

//draw for etch, only moves etch
function etchDraw(){
    //move etch
    etchMove(); 
}

//moves etch if a movement key is down
function etchMove(){
    if (keyIsPressed && keyCheck())
        etch1.forward(etch1.speed);
}

//check if the key down is a movement key
function keyCheck(){
    if (key === 'w' || key === 'a' ||
        key === 's' || key === 'd')
            return true;
    else
        return false;
}

//key pressed for etch, turns the turtle
function etchKeyPressed(){
    if(key === 'w'){
        etch1.face(270);
    }
    if(key === 'a'){
        etch1.face(180);
    }
    if(key === 's'){
        etch1.face(90);
    }
    if(key === 'd'){
        etch1.face(0);
    }
}